/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the AccountScope type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AccountScope{}

// AccountScope struct for AccountScope
type AccountScope struct {
	DisplayName            string         `json:"displayName"`
	AccountScopeIdentifier string         `json:"accountScopeIdentifier"`
	Id                     NullableString `json:"id,omitempty"`
	CreationTime           *time.Time     `json:"creationTime,omitempty"`
}

type _AccountScope AccountScope

// NewAccountScope instantiates a new AccountScope object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAccountScope(displayName string, accountScopeIdentifier string) *AccountScope {
	this := AccountScope{}
	this.DisplayName = displayName
	this.AccountScopeIdentifier = accountScopeIdentifier
	return &this
}

// NewAccountScopeWithDefaults instantiates a new AccountScope object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAccountScopeWithDefaults() *AccountScope {
	this := AccountScope{}
	return &this
}

// GetDisplayName returns the DisplayName field value
func (o *AccountScope) GetDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value
// and a boolean to check if the value has been set.
func (o *AccountScope) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayName, true
}

// SetDisplayName sets field value
func (o *AccountScope) SetDisplayName(v string) {
	o.DisplayName = v
}

// GetAccountScopeIdentifier returns the AccountScopeIdentifier field value
func (o *AccountScope) GetAccountScopeIdentifier() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AccountScopeIdentifier
}

// GetAccountScopeIdentifierOk returns a tuple with the AccountScopeIdentifier field value
// and a boolean to check if the value has been set.
func (o *AccountScope) GetAccountScopeIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AccountScopeIdentifier, true
}

// SetAccountScopeIdentifier sets field value
func (o *AccountScope) SetAccountScopeIdentifier(v string) {
	o.AccountScopeIdentifier = v
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AccountScope) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AccountScope) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *AccountScope) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *AccountScope) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *AccountScope) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *AccountScope) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *AccountScope) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AccountScope) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *AccountScope) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *AccountScope) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o AccountScope) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AccountScope) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["displayName"] = o.DisplayName
	toSerialize["accountScopeIdentifier"] = o.AccountScopeIdentifier
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *AccountScope) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"displayName",
		"accountScopeIdentifier",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varAccountScope := _AccountScope{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varAccountScope)

	if err != nil {
		return err
	}

	*o = AccountScope(varAccountScope)

	return err
}

type NullableAccountScope struct {
	value *AccountScope
	isSet bool
}

func (v NullableAccountScope) Get() *AccountScope {
	return v.value
}

func (v *NullableAccountScope) Set(val *AccountScope) {
	v.value = val
	v.isSet = true
}

func (v NullableAccountScope) IsSet() bool {
	return v.isSet
}

func (v *NullableAccountScope) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAccountScope(val *AccountScope) *NullableAccountScope {
	return &NullableAccountScope{value: val, isSet: true}
}

func (v NullableAccountScope) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAccountScope) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
